// BlueIO_CommLog.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <winsock2.h>
#include "BlueIO_CommLog.h"
#include "MainFrm.h"

#include "BlueIO_CommLogDoc.h"
#include "BlueIO_CommLogView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BLUEIO_LIBRARY_HANDLE hBlueIO_lib = NULL;

// CBlueIO_CommLogApp

BEGIN_MESSAGE_MAP(CBlueIO_CommLogApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, &CBlueIO_CommLogApp::OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
END_MESSAGE_MAP()


// CBlueIO_CommLogApp construction

CBlueIO_CommLogApp::CBlueIO_CommLogApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CBlueIO_CommLogApp object

CBlueIO_CommLogApp theApp;


// CBlueIO_CommLogApp initialization

BOOL CBlueIO_CommLogApp::InitInstance()
{
	CWinApp::InitInstance();

	//Need to Call before calling any winsock functions
	ULONG				ulRetCode = 0;
	WSADATA				WSAData = {0};
 	if ( 0 != ( ulRetCode = WSAStartup(MAKEWORD(2, 2), &WSAData) ) )
 		printf("Unable to initialize Winsock version 2.2\n");

	hBlueIO_lib = BlueIO_Init();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CBlueIO_CommLogDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CBlueIO_CommLogView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);



	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);


	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	// call DragAcceptFiles only if there's a suffix
	//  In an SDI app, this should occur after ProcessShellCommand
	return TRUE;
}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CBlueIO_CommLogApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CBlueIO_CommLogApp message handlers


int CBlueIO_CommLogApp::ExitInstance()
{
	if (hBlueIO_lib)
		BlueIO_Uninit(hBlueIO_lib);
	hBlueIO_lib = NULL;

	//Clean up all the winsock services.
 	WSACleanup();

	return CWinApp::ExitInstance();
}

BOOL CAboutDlg::OnInitDialog()
{
	gtype_uint16 majorVersion = 1;
	gtype_uint16 minorVersion = 0;
	WCHAR tmpstring[100];

	CDialog::OnInitDialog();

	BlueIO_GetDLLVersion(hBlueIO_lib, &majorVersion, &minorVersion);
	CWnd *pWnd = GetDlgItem(IDC_LIB_VERSION);
	if (pWnd)
	{
		wsprintf(tmpstring, L"This app is linked to BlueIO library version %d.%02d", majorVersion, minorVersion);
		pWnd->SetWindowText(tmpstring);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
