// BlueIO_CommLogView.cpp : implementation of the CBlueIO_CommLogView class
//

#include "stdafx.h"
#include "BlueIO_CommLog.h"

#include "BlueIO_CommLogDoc.h"
#include "MainFrm.h"
#include "BlueIO_CommLogView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifndef GSTD_S
#define GSTD_S(x) L##x
#endif

/////////////////////////////////////////////////////////////////////////////
// CBlueIO_CommLogView

IMPLEMENT_DYNCREATE(CBlueIO_CommLogView, CListView)

BEGIN_MESSAGE_MAP(CBlueIO_CommLogView, CListView)
	//{{AFX_MSG_MAP(CBlueIO_CommLogView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlueIO_CommLogView construction/destruction

CBlueIO_CommLogView::CBlueIO_CommLogView()
{
	// TODO: add construction code here

}

CBlueIO_CommLogView::~CBlueIO_CommLogView()
{
}

BOOL CBlueIO_CommLogView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style &= ~LVS_TYPEMASK;
	cs.style |= LVS_REPORT;

	return CListView::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CBlueIO_CommLogView drawing

void CBlueIO_CommLogView::OnDraw(CDC* pDC)
{
	CBlueIO_CommLogDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CBlueIO_CommLogView diagnostics

#ifdef _DEBUG
void CBlueIO_CommLogView::AssertValid() const
{
	CListView::AssertValid();
}

void CBlueIO_CommLogView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CBlueIO_CommLogDoc* CBlueIO_CommLogView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBlueIO_CommLogDoc)));
	return (CBlueIO_CommLogDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBlueIO_CommLogView message handlers

#define NUM_COLUMNS 6

static _TCHAR *_gszColumnLabel[NUM_COLUMNS] =
{
	_T("Time"), _T("IN/OUT"), _T("Name"), _T("# bytes"), _T("Ascii"), _T("Hex")
};

static int _gnColumnFmt[NUM_COLUMNS] =
{
	LVCFMT_RIGHT, LVCFMT_RIGHT, LVCFMT_RIGHT, LVCFMT_RIGHT, LVCFMT_LEFT, LVCFMT_LEFT
};

static int _gnColumnWidth[NUM_COLUMNS] =
{
	80, 60, 80, 60, 300, 700
};

void CBlueIO_CommLogView::OnInitialUpdate() 
{
	CListView::OnInitialUpdate();
	
	CListCtrl& ListCtrl = GetListCtrl();
	if (ListCtrl.GetItemCount() > 0)
		ListCtrl.DeleteAllItems();
	else
	{
		int i;
		LV_COLUMN lvc;

		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		for(i = 0; i<NUM_COLUMNS; i++)
		{
			lvc.iSubItem = i;
			lvc.pszText = _gszColumnLabel[i];
			lvc.cx = _gnColumnWidth[i];
			lvc.fmt = _gnColumnFmt[i];
			ListCtrl.InsertColumn(i,&lvc);
		}
	}
}

void CBlueIO_CommLogView::RecordBlueIOOutput(LPCSTR pBuf, int buf_len, LPCTSTR port)
{
	RecordBlueIOString(pBuf, buf_len, GSTD_S("OUT"), port);
}

void CBlueIO_CommLogView::RecordBlueIOInput(LPCSTR pBuf, int buf_len, LPCTSTR port)
{
	RecordBlueIOString(pBuf, buf_len, GSTD_S("IN"), port);
}

void CBlueIO_CommLogView::RecordBlueIOString(LPCSTR pBuf, int buf_len, LPCTSTR label, LPCTSTR port)
{
	CListCtrl& ListCtrl = GetListCtrl();
	CTime theTime;
	theTime = CTime::GetCurrentTime();
	CString time_string = theTime.Format(GSTD_S("%H:%M:%S"));
	int new_index = ListCtrl.GetItemCount();
	int i, record_len;
	CString short_string;
	TCHAR tmpstring[100];

	while (buf_len > 0)
	{
		ListCtrl.InsertItem(new_index, (LPCTSTR) time_string);
		ListCtrl.SetItemText(new_index, 1, label);
		ListCtrl.SetItemText(new_index, 2, port);
		record_len = buf_len;
		if (record_len > REPORT_RECORD_DATA_LENGTH)
			record_len = REPORT_RECORD_DATA_LENGTH;
		wsprintf(tmpstring, GSTD_S("%d"), record_len);
		ListCtrl.SetItemText(new_index, 3, tmpstring);

		short_string = "";
		for (i = 0; i < record_len; i++)
		{
			if (pBuf[i] == 0)
				short_string += '.';
			else
				short_string += pBuf[i];
		}
		ListCtrl.SetItemText(new_index, 4, (LPCTSTR) short_string);

		short_string = "";
		for (i = 0; i < record_len; i++)
		{
			wsprintf(tmpstring, GSTD_S("%02x "), (BYTE) (pBuf[i]));
			short_string += tmpstring;
		}
		ListCtrl.SetItemText(new_index, 5, (LPCTSTR) short_string);
		ListCtrl.EnsureVisible(new_index, FALSE);

		buf_len -= record_len;
		pBuf += record_len;
		new_index++;
	}
}

void CBlueIO_CommLogView::RecordBlueIOComment(LPCTSTR pBuf)
{
	CListCtrl& ListCtrl = GetListCtrl();
	CTime theTime;
	theTime = CTime::GetCurrentTime();
	CString time_string = theTime.Format("%H:%M:%S");
	int new_index = ListCtrl.GetItemCount();

	ListCtrl.InsertItem(new_index, (LPCTSTR) time_string);
	ListCtrl.SetItemText(new_index, 1, GSTD_S(""));
	ListCtrl.SetItemText(new_index, 2, GSTD_S(""));
	ListCtrl.SetItemText(new_index, 3, pBuf);
	ListCtrl.SetItemText(new_index, 4, GSTD_S(""));
	ListCtrl.EnsureVisible(new_index, FALSE);
}
