// BlueIO_CommLogView.h : interface of the CBlueIO_CommLogView class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#define REPORT_RECORD_DATA_LENGTH 32

class CBlueIO_CommLogDoc;

class CBlueIO_CommLogView : public CListView
{
protected: // create from serialization only
	CBlueIO_CommLogView();
	DECLARE_DYNCREATE(CBlueIO_CommLogView)

// Attributes
public:
	CBlueIO_CommLogDoc* GetDocument();

// Operations
public:
	void RecordBlueIOInput(LPCSTR pBuf, int buf_len, LPCTSTR port = NULL);
	void RecordBlueIOOutput(LPCSTR pBuf, int buf_len, LPCTSTR port = NULL);
	void RecordBlueIOComment(LPCTSTR pBuf);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBlueIO_CommLogView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBlueIO_CommLogView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void RecordBlueIOString(LPCSTR pBuf, int buf_len, LPCTSTR label, LPCTSTR port = NULL);

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BlueIO_CommLogView.cpp
inline CBlueIO_CommLogDoc* CBlueIO_CommLogView::GetDocument()
   { return (CBlueIO_CommLogDoc*)m_pDocument; }
#endif

