// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include <math.h>
#include <sstream>
#include <iomanip>
#include "BlueIO_CommLog.h"
#include "BlueIO_CommLogDoc.h"
#include "BlueIO_CommLogView.h"
#include "SetMeasPeriodDlg.h"

#include "MainFrm.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define TIMER_PERIOD_MS 250

// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(IDM_GET_STATUS, &CMainFrame::OnUpdateGetStatus)
	ON_COMMAND(IDM_GET_STATUS, &CMainFrame::OnGetStatus)
	ON_UPDATE_COMMAND_UI(IDM_SET_MEAS_PERIOD, &CMainFrame::OnUpdateSetMeasPeriod)
	ON_COMMAND(IDM_SET_MEAS_PERIOD, &CMainFrame::OnSetMeasPeriod)
	ON_COMMAND(IDM_SEARCHFORBLUETOOTHDEVICES, &CMainFrame::OnSearchforbluetoothdevices)
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(IDM_DEVICE0, &CMainFrame::OnDevice0)
	ON_COMMAND(IDM_DEVICE1, &CMainFrame::OnDevice1)
	ON_COMMAND(IDM_DEVICE2, &CMainFrame::OnDevice2)
	ON_COMMAND(IDM_DEVICE3, &CMainFrame::OnDevice3)
	ON_COMMAND(IDM_DEVICE4, &CMainFrame::OnDevice4)
	ON_COMMAND(IDM_DEVICE5, &CMainFrame::OnDevice5)
	ON_COMMAND(IDM_DEVICE6, &CMainFrame::OnDevice6)
	ON_COMMAND(IDM_DEVICE7, &CMainFrame::OnDevice7)
	ON_WM_TIMER()
	ON_UPDATE_COMMAND_UI(IDM_START_MEAS, &CMainFrame::OnUpdateStartMeas)
	ON_COMMAND(IDM_START_MEAS, &CMainFrame::OnStartMeas)
	ON_UPDATE_COMMAND_UI(IDM_STOP_MEAS, &CMainFrame::OnUpdateStopMeas)
	ON_COMMAND(IDM_STOP_MEAS, &CMainFrame::OnStopMeas)
	ON_UPDATE_COMMAND_UI(IDM_GREEN, &CMainFrame::OnUpdateGreen)
	ON_COMMAND(IDM_GREEN, &CMainFrame::OnGreen)
	ON_UPDATE_COMMAND_UI(IDM_RED, &CMainFrame::OnUpdateRed)
	ON_COMMAND(IDM_RED, &CMainFrame::OnRed)
	ON_UPDATE_COMMAND_UI(IDM_ORANGE, &CMainFrame::OnUpdateOrange)
	ON_COMMAND(IDM_ORANGE, &CMainFrame::OnOrange)
	ON_UPDATE_COMMAND_UI(IDM_LED_OFF, &CMainFrame::OnUpdateLedOff)
	ON_COMMAND(IDM_LED_OFF, &CMainFrame::OnLedOff)
	ON_UPDATE_COMMAND_UI(IDM_LED_BLINK, &CMainFrame::OnUpdateLedBlink)
	ON_COMMAND(IDM_LED_BLINK, &CMainFrame::OnLedBlink)
	ON_UPDATE_COMMAND_UI(IDM_READ_SENSOR3_DDS, &CMainFrame::OnUpdateReadSensor3Dds)
	ON_COMMAND(IDM_READ_SENSOR3_DDS, &CMainFrame::OnReadSensor3Dds)
	ON_UPDATE_COMMAND_UI(IDM_READ_SENSOR4_DDS, &CMainFrame::OnUpdateReadSensor4Dds)
	ON_COMMAND(IDM_READ_SENSOR4_DDS, &CMainFrame::OnReadSensor4Dds)
	ON_UPDATE_COMMAND_UI(IDM_READ_SENSOR5_DDS, &CMainFrame::OnUpdateReadSensor5Dds)
	ON_COMMAND(IDM_READ_SENSOR5_DDS, &CMainFrame::OnReadSensor5Dds)
	ON_UPDATE_COMMAND_UI(IDM_READ_SENSOR6_DDS, &CMainFrame::OnUpdateReadSensor6Dds)
	ON_COMMAND(IDM_READ_SENSOR6_DDS, &CMainFrame::OnReadSensor6Dds)
	ON_UPDATE_COMMAND_UI(IDM_READ_SENSOR7_DDS, &CMainFrame::OnUpdateReadSensor7Dds)
	ON_COMMAND(IDM_READ_SENSOR7_DDS, &CMainFrame::OnReadSensor7Dds)
	ON_UPDATE_COMMAND_UI(IDM_READ_FLASH, &CMainFrame::OnUpdateReadFlash)
	ON_COMMAND(IDM_READ_FLASH, &CMainFrame::OnReadFlash)
END_MESSAGE_MAP()


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_timerId = 0;
	m_bIsCollectingMeasurements = false;
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_wndCollectBar.Create(this, IDD_COLLECT_BAR, CBRS_TOP, IDD_COLLECT_BAR);
	m_wndCollectBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);

	DockControlBar(&m_wndCollectBar);

/*
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
*/
	m_timerId = SetTimer(777, TIMER_PERIOD_MS, NULL);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers




void CMainFrame::OnUpdateGetStatus(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnGetStatus()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		WDSSGetStatusCmdResponsePayload response;
		gtype_uint32 responseSize = sizeof(response);
		gtype_int32 nResult = BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_GET_STATUS, NULL, 0, 
			&response, &responseSize, BLUEIO_TIMEOUT_MS_DEFAULT);
		if (0 == nResult)
		{
			std::wstringstream ss;
			double version = (response.base.majorVersionMasterCPU/0x10)*10.0 + (response.base.majorVersionMasterCPU & 0xf)*1.0 + 
					(response.base.minorVersionMasterCPU/0x10)*0.1 + (response.base.minorVersionMasterCPU & 0xf)*0.01;
			ss << "Status = " << hex << response.base.status;
			ss << "h ; statusX1 = " << response.statusX1;
			ss << "h ; version = ";
			ss << fixed << uppercase << showpoint << setprecision(2) << version;
			std::wstring str = ss.str();
			MessageBox(str.c_str(), L"BLUEIO_CMD_ID_GET_STATUS");
		}
	}
}

void CMainFrame::OnUpdateSetMeasPeriod(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnSetMeasPeriod()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		CSetMeasPeriodDlg dlg;
		gtype_real64 period_sec;
		BlueIO_Device_GetMeasurementPeriod(hDevice, &period_sec, BLUEIO_TIMEOUT_MS_DEFAULT);
		dlg.m_period_ms = (unsigned int) floor(1000.0*period_sec + 0.5);
		if (IDOK == dlg.DoModal())
		{
			BlueIO_Device_SetMeasurementPeriod(hDevice, dlg.m_period_ms/1000.0, BLUEIO_TIMEOUT_MS_DEFAULT);
		}
	}
}

void CMainFrame::OnSearchforbluetoothdevices()
{
	HCURSOR hcurSave = SetCursor(::LoadCursor(NULL,IDC_WAIT));
	gtype_uint32 sig;
	BlueIO_SearchForDevices(hBlueIO_lib, BLUEIO_DEVTYPE_WDSS, NULL, &sig);
	SetCursor(hcurSave);
}

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
{
	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();

	if ((2 == nIndex) && pDoc)
	{
		while (pPopupMenu->GetMenuItemCount() > 0)
			pPopupMenu->DeleteMenu(0, MF_BYPOSITION);

		pPopupMenu->AppendMenu(MF_STRING, IDM_SEARCHFORBLUETOOTHDEVICES, L"Search for Bluetooth devices");
		pPopupMenu->AppendMenu(MF_SEPARATOR);

		gtype_uint32 count, sig, i, statusMask;
		char deviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
		int nResult;
		BLUEIO_DEVICE_LIST_HANDLE hList = BlueIO_OpenDeviceListSnapshot(hBlueIO_lib,
			BLUEIO_DEVTYPE_WDSS, &count, &sig);
		if (hList)
		{
			for (i = 0; i < count; i++)
			{
				nResult = BlueIO_DeviceListSnapshot_GetNthEntry(hList, i, deviceName, sizeof(deviceName), &statusMask);
				if (0 == nResult)
				{
					WCHAR wdeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
					MultiByteToWideChar(CP_ACP, 0, deviceName, -1, wdeviceName, BLUEIO_MAX_SIZE_DEVICE_NAME);

					pPopupMenu->AppendMenu(MF_STRING, IDM_DEVICE0 + i, wdeviceName);
					if (statusMask != 0)
						pPopupMenu->CheckMenuItem(IDM_DEVICE0 + i, MF_BYCOMMAND | MF_CHECKED);
				}
			}
			BlueIO_CloseDeviceListSnapshot(hList);
		}
	}
}

void CMainFrame::OnDevice0()
{
	OnDeviceN(0);
}

void CMainFrame::OnDevice1()
{
	OnDeviceN(1);
}

void CMainFrame::OnDevice2()
{
	OnDeviceN(2);
}

void CMainFrame::OnDevice3()
{
	OnDeviceN(3);
}

void CMainFrame::OnDevice4()
{
	OnDeviceN(4);
}

void CMainFrame::OnDevice5()
{
	OnDeviceN(5);
}

void CMainFrame::OnDevice6()
{
	OnDeviceN(6);
}

void CMainFrame::OnDevice7()
{
	OnDeviceN(7);
}

void CMainFrame::OnDeviceN(unsigned int N) 
{
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
	{
		char newDeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
		char oldDeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
		CMenu *pMenu = GetMenu();
		int nResult = 0;
		newDeviceName[0] = 0;
		oldDeviceName[0] = 0;
		if (pMenu)
		{
			WCHAR wNewDeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
			nResult = pMenu->GetMenuString(IDM_DEVICE0 + N, wNewDeviceName, BLUEIO_MAX_SIZE_DEVICE_NAME, MF_BYCOMMAND);
			if (nResult > 0)
			{
				WideCharToMultiByte(CP_ACP, 0, wNewDeviceName, -1, newDeviceName, sizeof(newDeviceName), NULL, NULL);
			}
		}
		if (nResult > 0)
		{
			BLUEIO_DEVICE_HANDLE hOldDevice = pDoc->GetOpenDevicePtr();
			if (hOldDevice)
			{
				BlueIO_Device_GetOpenDeviceName(hOldDevice, oldDeviceName, sizeof(oldDeviceName));
				pDoc->CloseDevice();
			}
			if (strncmp(oldDeviceName, newDeviceName, BLUEIO_MAX_SIZE_DEVICE_NAME) != 0)
				pDoc->OpenDevice(newDeviceName);
			m_bIsCollectingMeasurements = false;
		}
	}
}

BOOL CMainFrame::DestroyWindow()
{
	if (m_timerId != 0)
		KillTimer(m_timerId);
	m_timerId = 0;
	
	return CFrameWnd::DestroyWindow();
}

void CMainFrame::OnTimer(UINT_PTR nIDEvent)
{
	unsigned char Buf[10000];
	char deviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
	WCHAR wdeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
	WCHAR tmpstring[100];
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	CBlueIO_CommLogView *pView = (CBlueIO_CommLogView *) GetActiveView();
	deviceName[0] = 0;
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (pView && hDevice)
	{
		int count;
		count = BlueIO_Diags_GetNumOutputTraceBytesAvailable(hDevice);
		if (count > 0)
		{
			count = BlueIO_Diags_ReadOutputTraceBytes(hDevice, Buf, sizeof(Buf));
			BlueIO_Device_GetOpenDeviceName(hDevice, deviceName, sizeof(deviceName));
			MultiByteToWideChar(CP_ACP, 0, deviceName, -1, wdeviceName, BLUEIO_MAX_SIZE_DEVICE_NAME);
			pView->RecordBlueIOOutput((LPCSTR) Buf, count, wdeviceName);
		}
		count = BlueIO_Diags_GetNumInputTraceBytesAvailable(hDevice);
		if (count > 0)
		{
			count = BlueIO_Diags_ReadInputTraceBytes(hDevice, Buf, sizeof(Buf));
			if (0 == deviceName[0])
			{
				BlueIO_Device_GetOpenDeviceName(hDevice, deviceName, sizeof(deviceName));
				MultiByteToWideChar(CP_ACP, 0, deviceName, -1, wdeviceName, BLUEIO_MAX_SIZE_DEVICE_NAME);
			}
			pView->RecordBlueIOInput((LPCSTR) Buf, count, wdeviceName);
		}

		count = BlueIO_Device_GetNumMeasurementsAvailable(hDevice, WDSS_CHANNEL_COMBINED_FORCE);
		if (count > 0)
		{
			int iMeas = BlueIO_Device_GetLatestRawMeasurement(hDevice, WDSS_CHANNEL_COMBINED_FORCE);
			gtype_real64 volts = BlueIO_Device_ConvertToVoltage(hDevice, WDSS_CHANNEL_COMBINED_FORCE, iMeas);
			gtype_real64 rMeas = BlueIO_Device_CalibrateData(hDevice, WDSS_CHANNEL_COMBINED_FORCE, volts);
			swprintf(tmpstring, L"%9.5f", rMeas);
			m_wndCollectBar.SetDlgItemText(IDC_MEAS, tmpstring);

			unsigned char activeCalPageIndex;
			gtype_real32 a, b, c;
			char units[10];
			WCHAR wUnits[10];
			BlueIO_Device_DDSMem_GetActiveCalPage(hDevice, WDSS_CHANNEL_COMBINED_FORCE, &activeCalPageIndex);
			BlueIO_Device_DDSMem_GetCalPage(hDevice, WDSS_CHANNEL_COMBINED_FORCE, activeCalPageIndex,
				&a, &b, &c, units, sizeof(units));
			MultiByteToWideChar(CP_ACP, 0, units, -1, wUnits, 10);
			m_wndCollectBar.SetDlgItemText(IDC_UNITS, wUnits);
		}
		else if (!m_bIsCollectingMeasurements)
		{
			m_wndCollectBar.GetDlgItemText(IDC_MEAS, tmpstring, 20);
			tmpstring[20] = 0;
			if (wcscmp(tmpstring, L"0.0") != 0)
				m_wndCollectBar.SetDlgItemText(IDC_MEAS, L"0.0");
		}
	}
}

void CMainFrame::OnUpdateStartMeas(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnStartMeas()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIO_Device_ClearIO(hDevice, -1);
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_START_MEASUREMENTS, NULL, 0, NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
		m_bIsCollectingMeasurements = true;
	}
}

void CMainFrame::OnUpdateStopMeas(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnStopMeas()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_STOP_MEASUREMENTS, NULL, 0, NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	m_bIsCollectingMeasurements = false;
}

void CMainFrame::OnUpdateGreen(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnGreen()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOSetLedStateParams params;
		params.brightness = BLUEIO_LED_BRIGHTNESS_MAX;
		params.LEDchannel = WDSS_COLLECTION_LED;
		params.color = BLUEIO_LED_COLOR_GREEN;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &params, sizeof(params), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	}
}

void CMainFrame::OnUpdateRed(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnRed()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOSetLedStateParams params;
		params.brightness = BLUEIO_LED_BRIGHTNESS_MAX;
		params.LEDchannel = WDSS_COLLECTION_LED;
		params.color = BLUEIO_LED_COLOR_RED;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &params, sizeof(params), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	}
}

void CMainFrame::OnUpdateOrange(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnOrange()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOSetLedStateParams params;
		params.brightness = BLUEIO_LED_BRIGHTNESS_MAX/4;
		params.LEDchannel = WDSS_COLLECTION_LED;
		params.color = BLUEIO_LED_COLOR_RED_GREEN;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &params, sizeof(params), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	}
}

void CMainFrame::OnUpdateLedOff(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnLedOff()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOSetLedStateParams params;
		params.brightness = BLUEIO_LED_BRIGHTNESS_MIN;
		params.LEDchannel = WDSS_COLLECTION_LED;
		params.color = BLUEIO_LED_COLOR_RED;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &params, sizeof(params), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	}
}

void CMainFrame::OnUpdateLedBlink(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnLedBlink()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOGetLedStateCmdResponsePayload oldLedState;
		BlueIOGetLedStateParams chanParams;
		int i;
		BlueIOSetLedStateParams onParams, offParams;
		gtype_uint32 responseSize = sizeof(oldLedState);

		HCURSOR hcurSave = SetCursor(::LoadCursor(NULL,IDC_WAIT));

		chanParams.LEDchannel = WDSS_COLLECTION_LED;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_GET_LED_STATE, &chanParams, sizeof(chanParams), 
			&oldLedState, &responseSize, BLUEIO_TIMEOUT_MS_DEFAULT);
		if ((BLUEIO_LED_COLOR_RED == oldLedState.color) || (BLUEIO_LED_COLOR_GREEN == oldLedState.color))
			onParams.color = oldLedState.color;
		else
			onParams.color = BLUEIO_LED_COLOR_RED;
		onParams.brightness = BLUEIO_LED_BRIGHTNESS_MAX;
		onParams.LEDchannel = WDSS_COLLECTION_LED;
		offParams.brightness = BLUEIO_LED_BRIGHTNESS_MIN;
		offParams.color = BLUEIO_LED_COLOR_RED;
		offParams.LEDchannel = WDSS_COLLECTION_LED;

		for (i = 0; i < 10; i++)
		{
			BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &offParams, sizeof(offParams), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
			Sleep(200);
			BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &onParams, sizeof(onParams), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
			Sleep(200);
		}
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &offParams, sizeof(offParams), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
		Sleep(200);
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &oldLedState, sizeof(oldLedState), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);

		SetCursor(hcurSave);
	}
}

void CMainFrame::OnUpdateReadSensor3Dds(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnReadSensor3Dds()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIO_Device_DDSMem_ReadRecord(hDevice, WDSS_CHANNEL_BAROMETER, 1, BLUEIO_TIMEOUT_MS_READ_DDSMEMBLOCK);
	}
}

void CMainFrame::OnUpdateReadSensor4Dds(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnReadSensor4Dds()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIO_Device_DDSMem_ReadRecord(hDevice, WDSS_CHANNEL_ACCEL_Y, 1, BLUEIO_TIMEOUT_MS_READ_DDSMEMBLOCK);
	}
}

void CMainFrame::OnUpdateReadSensor5Dds(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnReadSensor5Dds()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIO_Device_DDSMem_ReadRecord(hDevice, WDSS_CHANNEL_ACCEL_X, 1, BLUEIO_TIMEOUT_MS_READ_DDSMEMBLOCK);
	}
}

void CMainFrame::OnUpdateReadSensor6Dds(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnReadSensor6Dds()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIO_Device_DDSMem_ReadRecord(hDevice, WDSS_CHANNEL_ACCEL_Z, 1, BLUEIO_TIMEOUT_MS_READ_DDSMEMBLOCK);
	}
}

void CMainFrame::OnUpdateReadSensor7Dds(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnReadSensor7Dds()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIO_Device_DDSMem_ReadRecord(hDevice, WDSS_CHANNEL_COMBINED_FORCE, 1, BLUEIO_TIMEOUT_MS_READ_DDSMEMBLOCK);
	}
}

void CMainFrame::OnUpdateReadFlash(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnReadFlash()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_CommLogDoc *pDoc = (CBlueIO_CommLogDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		char Buf[1000];
		BlueIO_Device_NVMemBlk_Read(hDevice, -1, Buf, 0, 1000, 5000);
	}
}
