// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include <math.h>
#include <sstream>
#include <iomanip>
#include "BlueIO_Measure.h"
#include "BlueIO_MeasureDoc.h"
#include "BlueIO_MeasureView.h"
#include "SetMeasPeriodDlg.h"

#include "MainFrm.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define TIMER_PERIOD_MS 70

// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(IDM_GET_STATUS, &CMainFrame::OnUpdateGetStatus)
	ON_COMMAND(IDM_GET_STATUS, &CMainFrame::OnGetStatus)
	ON_UPDATE_COMMAND_UI(IDM_SET_MEAS_PERIOD, &CMainFrame::OnUpdateSetMeasPeriod)
	ON_COMMAND(IDM_SET_MEAS_PERIOD, &CMainFrame::OnSetMeasPeriod)
	ON_COMMAND(IDM_SEARCHFORBLUETOOTHDEVICES, &CMainFrame::OnSearchforbluetoothdevices)
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(IDM_DEVICE0, &CMainFrame::OnDevice0)
	ON_COMMAND(IDM_DEVICE1, &CMainFrame::OnDevice1)
	ON_COMMAND(IDM_DEVICE2, &CMainFrame::OnDevice2)
	ON_COMMAND(IDM_DEVICE3, &CMainFrame::OnDevice3)
	ON_COMMAND(IDM_DEVICE4, &CMainFrame::OnDevice4)
	ON_COMMAND(IDM_DEVICE5, &CMainFrame::OnDevice5)
	ON_COMMAND(IDM_DEVICE6, &CMainFrame::OnDevice6)
	ON_COMMAND(IDM_DEVICE7, &CMainFrame::OnDevice7)
	ON_WM_TIMER()
	ON_UPDATE_COMMAND_UI(IDM_START_MEAS, &CMainFrame::OnUpdateStartMeas)
	ON_COMMAND(IDM_START_MEAS, &CMainFrame::OnStartMeas)
	ON_UPDATE_COMMAND_UI(IDM_STOP_MEAS, &CMainFrame::OnUpdateStopMeas)
	ON_COMMAND(IDM_STOP_MEAS, &CMainFrame::OnStopMeas)
	ON_UPDATE_COMMAND_UI(IDM_GREEN, &CMainFrame::OnUpdateGreen)
	ON_COMMAND(IDM_GREEN, &CMainFrame::OnGreen)
	ON_UPDATE_COMMAND_UI(IDM_RED, &CMainFrame::OnUpdateRed)
	ON_COMMAND(IDM_RED, &CMainFrame::OnRed)
	ON_UPDATE_COMMAND_UI(IDM_ORANGE, &CMainFrame::OnUpdateOrange)
	ON_COMMAND(IDM_ORANGE, &CMainFrame::OnOrange)
	ON_UPDATE_COMMAND_UI(IDM_LED_OFF, &CMainFrame::OnUpdateLedOff)
	ON_COMMAND(IDM_LED_OFF, &CMainFrame::OnLedOff)
	ON_UPDATE_COMMAND_UI(IDM_LED_BLINK, &CMainFrame::OnUpdateLedBlink)
	ON_COMMAND(IDM_LED_BLINK, &CMainFrame::OnLedBlink)
	ON_UPDATE_COMMAND_UI(ID_CHANNEL_ALTIMETER, &CMainFrame::OnUpdateChannelAltimeter)
	ON_COMMAND(ID_CHANNEL_ALTIMETER, &CMainFrame::OnChannelAltimeter)
	ON_UPDATE_COMMAND_UI(ID_CHANNEL_ACCELY, &CMainFrame::OnUpdateChannelAccely)
	ON_COMMAND(ID_CHANNEL_ACCELY, &CMainFrame::OnChannelAccely)
	ON_UPDATE_COMMAND_UI(ID_CHANNEL_ACCELX, &CMainFrame::OnUpdateChannelAccelx)
	ON_COMMAND(ID_CHANNEL_ACCELX, &CMainFrame::OnChannelAccelx)
	ON_UPDATE_COMMAND_UI(ID_CHANNEL_ACCELZ, &CMainFrame::OnUpdateChannelAccelz)
	ON_COMMAND(ID_CHANNEL_ACCELZ, &CMainFrame::OnChannelAccelz)
	ON_UPDATE_COMMAND_UI(ID_CHANNEL_COMBINEDFORCE, &CMainFrame::OnUpdateChannelCombinedforce)
	ON_COMMAND(ID_CHANNEL_COMBINEDFORCE, &CMainFrame::OnChannelCombinedforce)
END_MESSAGE_MAP()


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_timerId = 0;
	m_bIsCollectingMeasurements = false;
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_wndCollectBar.Create(this, IDD_COLLECT_BAR, CBRS_TOP, IDD_COLLECT_BAR);
	m_wndCollectBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);

	DockControlBar(&m_wndCollectBar);

/*
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
*/
	m_timerId = SetTimer(777, TIMER_PERIOD_MS, NULL);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers




void CMainFrame::OnUpdateGetStatus(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnGetStatus()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		WDSSGetStatusCmdResponsePayload response;
		gtype_uint32 responseSize = sizeof(response);
		gtype_int32 nResult = BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_GET_STATUS, NULL, 0, 
			&response, &responseSize, BLUEIO_TIMEOUT_MS_DEFAULT);
		if (0 == nResult)
		{
			std::wstringstream ss;
			double version = (response.base.majorVersionMasterCPU/0x10)*10.0 + (response.base.majorVersionMasterCPU & 0xf)*1.0 + 
					(response.base.minorVersionMasterCPU/0x10)*0.1 + (response.base.minorVersionMasterCPU & 0xf)*0.01;
			ss << "Status = " << hex << response.base.status;
			ss << "h ; statusX1 = " << response.statusX1;
			ss << "h ; version = ";
			ss << fixed << uppercase << showpoint << setprecision(2) << version;
			std::wstring str = ss.str();
			MessageBox(str.c_str(), L"BLUEIO_CMD_ID_GET_STATUS");
		}
	}
}

void CMainFrame::OnUpdateSetMeasPeriod(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnSetMeasPeriod()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		CSetMeasPeriodDlg dlg;
		gtype_real64 period_sec;
		BlueIO_Device_GetMeasurementPeriod(hDevice, &period_sec, BLUEIO_TIMEOUT_MS_DEFAULT);
		dlg.m_period_ms = (unsigned int) floor(1000.0*period_sec + 0.5);
		if (IDOK == dlg.DoModal())
		{
			BlueIO_Device_SetMeasurementPeriod(hDevice, dlg.m_period_ms/1000.0, BLUEIO_TIMEOUT_MS_DEFAULT);
		}
	}
}

void CMainFrame::OnSearchforbluetoothdevices()
{
	HCURSOR hcurSave = SetCursor(::LoadCursor(NULL,IDC_WAIT));
	gtype_uint32 sig;
	BlueIO_SearchForDevices(hBlueIO_lib, BLUEIO_DEVTYPE_WDSS, NULL, &sig);
	SetCursor(hcurSave);
}

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
{
	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();

	if ((2 == nIndex) && pDoc)
	{
		while (pPopupMenu->GetMenuItemCount() > 0)
			pPopupMenu->DeleteMenu(0, MF_BYPOSITION);

		pPopupMenu->AppendMenu(MF_STRING, IDM_SEARCHFORBLUETOOTHDEVICES, L"Search for Bluetooth devices");
		pPopupMenu->AppendMenu(MF_SEPARATOR);

		gtype_uint32 count, sig, i, statusMask;
		char deviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
		int nResult;
		BLUEIO_DEVICE_LIST_HANDLE hList = BlueIO_OpenDeviceListSnapshot(hBlueIO_lib,
			BLUEIO_DEVTYPE_WDSS, &count, &sig);
		if (hList)
		{
			for (i = 0; i < count; i++)
			{
				nResult = BlueIO_DeviceListSnapshot_GetNthEntry(hList, i, deviceName, sizeof(deviceName), &statusMask);
				if (0 == nResult)
				{
					WCHAR wdeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
					MultiByteToWideChar(CP_ACP, 0, deviceName, -1, wdeviceName, BLUEIO_MAX_SIZE_DEVICE_NAME);

					pPopupMenu->AppendMenu(MF_STRING, IDM_DEVICE0 + i, wdeviceName);
					if (statusMask != 0)
						pPopupMenu->CheckMenuItem(IDM_DEVICE0 + i, MF_BYCOMMAND | MF_CHECKED);
				}
			}
			BlueIO_CloseDeviceListSnapshot(hList);
		}
	}
}

void CMainFrame::OnDevice0()
{
	OnDeviceN(0);
}

void CMainFrame::OnDevice1()
{
	OnDeviceN(1);
}

void CMainFrame::OnDevice2()
{
	OnDeviceN(2);
}

void CMainFrame::OnDevice3()
{
	OnDeviceN(3);
}

void CMainFrame::OnDevice4()
{
	OnDeviceN(4);
}

void CMainFrame::OnDevice5()
{
	OnDeviceN(5);
}

void CMainFrame::OnDevice6()
{
	OnDeviceN(6);
}

void CMainFrame::OnDevice7()
{
	OnDeviceN(7);
}

void CMainFrame::OnDeviceN(unsigned int N) 
{
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
	{
		char newDeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
		char oldDeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
		CMenu *pMenu = GetMenu();
		int nResult = 0;
		newDeviceName[0] = 0;
		oldDeviceName[0] = 0;
		if (pMenu)
		{
			WCHAR wNewDeviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
			nResult = pMenu->GetMenuString(IDM_DEVICE0 + N, wNewDeviceName, BLUEIO_MAX_SIZE_DEVICE_NAME, MF_BYCOMMAND);
			if (nResult > 0)
			{
				WideCharToMultiByte(CP_ACP, 0, wNewDeviceName, -1, newDeviceName, sizeof(newDeviceName), NULL, NULL);
			}
		}
		if (nResult > 0)
		{
			BLUEIO_DEVICE_HANDLE hOldDevice = pDoc->GetOpenDevicePtr();
			if (hOldDevice)
			{
				BlueIO_Device_GetOpenDeviceName(hOldDevice, oldDeviceName, sizeof(oldDeviceName));
				pDoc->CloseDevice();
			}
			if (strncmp(oldDeviceName, newDeviceName, BLUEIO_MAX_SIZE_DEVICE_NAME) != 0)
				pDoc->OpenDevice(newDeviceName);
			m_bIsCollectingMeasurements = false;
		}
	}
}

BOOL CMainFrame::DestroyWindow()
{
	if (m_timerId != 0)
		KillTimer(m_timerId);
	m_timerId = 0;
	
	return CFrameWnd::DestroyWindow();
}

void CMainFrame::OnTimer(UINT_PTR nIDEvent)
{
	char deviceName[BLUEIO_MAX_SIZE_DEVICE_NAME];
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	CBlueIO_MeasureView *pView = (CBlueIO_MeasureView *) GetActiveView();
	deviceName[0] = 0;
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (pView && hDevice)
	{
		gtype_int32 measurements[MAX_NUM_MEASUREMENTS_IN_CIRBUF];
		double rMeasurement, rTime;
		int numMeasurementsAvailable = BlueIO_Device_GetNumMeasurementsAvailable(hDevice, pDoc->GetActiveChannel());
		if (numMeasurementsAvailable > 0)
		{
			numMeasurementsAvailable = BlueIO_Device_ReadRawMeasurements(hDevice, pDoc->GetActiveChannel(),
				measurements, MAX_NUM_MEASUREMENTS_IN_CIRBUF);
		}

		if (numMeasurementsAvailable > 0)
		{
			//Stuff the new measurements in a local circular buffer.
			for (int k = 0; k < numMeasurementsAvailable; k++)
			{
				gtype_real64 volts = BlueIO_Device_ConvertToVoltage(hDevice, pDoc->GetActiveChannel(), measurements[k]);
				rMeasurement = BlueIO_Device_CalibrateData(hDevice, pDoc->GetActiveChannel(), volts);
				if (pDoc->GetNumMeasurementsInCirbuf() <= 0)
					rTime = 0.0;
				else
				{
					double rrr;
					pDoc->GetNthMeasurementInCirbuf(pDoc->GetNumMeasurementsInCirbuf() - 1, &rrr, &rTime);
					rTime += pDoc->GetMeasurementPeriodInSeconds();
				}
				pDoc->AddMeasurementToCirbuf(rMeasurement, rTime);
			}
			pView->Invalidate();
			pView->UpdateWindow();

			//Display latest measurement value on the toolbar.
			std::wstringstream ss;
			ss << fixed << uppercase << showpoint << setprecision(3) << rMeasurement;
			std::wstring strMeas = ss.str();
			m_wndCollectBar.SetDlgItemText(IDC_MEAS, strMeas.c_str());
		}
		else
		if (!m_bIsCollectingMeasurements)
			//Clear latest measurement value.
			m_wndCollectBar.SetDlgItemText(IDC_MEAS, L"");
	}
}

void CMainFrame::OnUpdateStartMeas(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL) && (!m_bIsCollectingMeasurements);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnStartMeas()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	CBlueIO_MeasureView *pView = (CBlueIO_MeasureView *) GetActiveView();
	if (pDoc && pView)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIO_Device_ClearIO(hDevice, -1);
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_START_MEASUREMENTS, NULL, 0, NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
		m_bIsCollectingMeasurements = true;
		pDoc->ClearMeasurementCirbuf();
		pView->SetGraphHistory(1.0, -1.0);//This clears the history.
		pView->Invalidate();
	}
}

void CMainFrame::OnUpdateStopMeas(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL) && m_bIsCollectingMeasurements;
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnStopMeas()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_STOP_MEASUREMENTS, NULL, 0, NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	m_bIsCollectingMeasurements = false;
}

void CMainFrame::OnUpdateGreen(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnGreen()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOSetLedStateParams params;
		params.brightness = BLUEIO_LED_BRIGHTNESS_MAX;
		params.LEDchannel = WDSS_COLLECTION_LED;
		params.color = BLUEIO_LED_COLOR_GREEN;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &params, sizeof(params), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	}
}

void CMainFrame::OnUpdateRed(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnRed()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOSetLedStateParams params;
		params.brightness = BLUEIO_LED_BRIGHTNESS_MAX;
		params.LEDchannel = WDSS_COLLECTION_LED;
		params.color = BLUEIO_LED_COLOR_RED;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &params, sizeof(params), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	}
}

void CMainFrame::OnUpdateOrange(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnOrange()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOSetLedStateParams params;
		params.brightness = BLUEIO_LED_BRIGHTNESS_MAX/4;
		params.LEDchannel = WDSS_COLLECTION_LED;
		params.color = BLUEIO_LED_COLOR_RED_GREEN;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &params, sizeof(params), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	}
}

void CMainFrame::OnUpdateLedOff(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnLedOff()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOSetLedStateParams params;
		params.brightness = BLUEIO_LED_BRIGHTNESS_MIN;
		params.LEDchannel = WDSS_COLLECTION_LED;
		params.color = BLUEIO_LED_COLOR_RED;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &params, sizeof(params), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
	}
}

void CMainFrame::OnUpdateLedBlink(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		bEnable = (pDoc->GetOpenDevicePtr() != NULL);
	pCmdUI->Enable(bEnable);
}

void CMainFrame::OnLedBlink()
{
	BLUEIO_DEVICE_HANDLE hDevice = NULL;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		hDevice = pDoc->GetOpenDevicePtr();
	if (hDevice)
	{
		BlueIOGetLedStateCmdResponsePayload oldLedState;
		BlueIOGetLedStateParams chanParams;
		int i;
		BlueIOSetLedStateParams onParams, offParams;
		gtype_uint32 responseSize = sizeof(oldLedState);

		HCURSOR hcurSave = SetCursor(::LoadCursor(NULL,IDC_WAIT));

		chanParams.LEDchannel = WDSS_COLLECTION_LED;
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_GET_LED_STATE, &chanParams, sizeof(chanParams), 
			&oldLedState, &responseSize, BLUEIO_TIMEOUT_MS_DEFAULT);
		if ((BLUEIO_LED_COLOR_RED == oldLedState.color) || (BLUEIO_LED_COLOR_GREEN == oldLedState.color))
			onParams.color = oldLedState.color;
		else
			onParams.color = BLUEIO_LED_COLOR_RED;
		onParams.brightness = BLUEIO_LED_BRIGHTNESS_MAX;
		onParams.LEDchannel = WDSS_COLLECTION_LED;
		offParams.brightness = BLUEIO_LED_BRIGHTNESS_MIN;
		offParams.color = BLUEIO_LED_COLOR_RED;
		offParams.LEDchannel = WDSS_COLLECTION_LED;

		for (i = 0; i < 10; i++)
		{
			BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &offParams, sizeof(offParams), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
			Sleep(200);
			BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &onParams, sizeof(onParams), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
			Sleep(200);
		}
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &offParams, sizeof(offParams), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);
		Sleep(200);
		BlueIO_Device_SendCmdAndGetResponse(hDevice, BLUEIO_CMD_ID_SET_LED_STATE, &oldLedState, sizeof(oldLedState), NULL, NULL, BLUEIO_TIMEOUT_MS_DEFAULT);

		SetCursor(hcurSave);
	}
}

void CMainFrame::OnUpdateChannelAltimeter(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	int checkState = 0;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
	{
		bEnable = (pDoc->GetOpenDevicePtr() != NULL) && (!m_bIsCollectingMeasurements);
		if (WDSS_CHANNEL_BAROMETER == pDoc->GetActiveChannel())
			checkState = 1;
	}
	pCmdUI->Enable(bEnable);
	pCmdUI->SetCheck(checkState);
}

void CMainFrame::OnChannelAltimeter()
{
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		pDoc->SetActiveChannel(WDSS_CHANNEL_BAROMETER);
}

void CMainFrame::OnUpdateChannelAccely(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	int checkState = 0;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
	{
		bEnable = (pDoc->GetOpenDevicePtr() != NULL) && (!m_bIsCollectingMeasurements);
		if (WDSS_CHANNEL_ACCEL_Y == pDoc->GetActiveChannel())
			checkState = 1;
	}
	pCmdUI->Enable(bEnable);
	pCmdUI->SetCheck(checkState);
}

void CMainFrame::OnChannelAccely()
{
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		pDoc->SetActiveChannel(WDSS_CHANNEL_ACCEL_Y);
}

void CMainFrame::OnUpdateChannelAccelx(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	int checkState = 0;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
	{
		bEnable = (pDoc->GetOpenDevicePtr() != NULL) && (!m_bIsCollectingMeasurements);
		if (WDSS_CHANNEL_ACCEL_X == pDoc->GetActiveChannel())
			checkState = 1;
	}
	pCmdUI->Enable(bEnable);
	pCmdUI->SetCheck(checkState);
}

void CMainFrame::OnChannelAccelx()
{
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		pDoc->SetActiveChannel(WDSS_CHANNEL_ACCEL_X);
}

void CMainFrame::OnUpdateChannelAccelz(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	int checkState = 0;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
	{
		bEnable = (pDoc->GetOpenDevicePtr() != NULL) && (!m_bIsCollectingMeasurements);
		if (WDSS_CHANNEL_ACCEL_Z == pDoc->GetActiveChannel())
			checkState = 1;
	}
	pCmdUI->Enable(bEnable);
	pCmdUI->SetCheck(checkState);
}

void CMainFrame::OnChannelAccelz()
{
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		pDoc->SetActiveChannel(WDSS_CHANNEL_ACCEL_Z);
}

void CMainFrame::OnUpdateChannelCombinedforce(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	int checkState = 0;
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
	{
		bEnable = (pDoc->GetOpenDevicePtr() != NULL) && (!m_bIsCollectingMeasurements);
		if (WDSS_CHANNEL_COMBINED_FORCE == pDoc->GetActiveChannel())
			checkState = 1;
	}
	pCmdUI->Enable(bEnable);
	pCmdUI->SetCheck(checkState);
}

void CMainFrame::OnChannelCombinedforce()
{
	CBlueIO_MeasureDoc *pDoc = (CBlueIO_MeasureDoc *) GetActiveDocument();
	if (pDoc)
		pDoc->SetActiveChannel(WDSS_CHANNEL_COMBINED_FORCE);
}
